var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/* Generated from Java with JSweet 2.0.1 - http://www.jsweet.org */
/**
 *
 * A good game.<p>
 *
 *
 * @version 	0.01, 19/10/2001
 * @author R�mi Peyronnet
 * @class
 * @extends java.applet.Applet
 */
var laby = (function (_super) {
    __extends(laby, _super);
    function laby() {
        var _this = _super.call(this) || this;
        if (_this.xmax === undefined)
            _this.xmax = 0;
        if (_this.ymax === undefined)
            _this.ymax = 0;
        if (_this.updt === undefined)
            _this.updt = false;
        if (_this.dbg === undefined)
            _this.dbg = false;
        if (_this.d === undefined)
            _this.d = null;
        if (_this.dx === undefined)
            _this.dx = 0;
        if (_this.dy === undefined)
            _this.dy = 0;
        if (_this.xshift === undefined)
            _this.xshift = 0;
        if (_this.yshift === undefined)
            _this.yshift = 0;
        if (_this.laby === undefined)
            _this.laby = null;
        if (_this.random === undefined)
            _this.random = null;
        return _this;
    }
    laby.dir_$LI$ = function () { if (laby.dir == null)
        laby.dir = [0, 1, 1, 0, 0, -1, -1, 0]; return laby.dir; };
    ;
    laby.prototype.getParameter = function (param) {
        switch ((param)) {
            case "xmax":
                return "100";
            case "ymax":
                return "60";
            case "updt":
                return "true";
            case "dbg":
                return "false";
            default:
                return "";
        }
    };
    laby.prototype.init = function () {
        java.lang.System.out.print("Laby - 2001 RP.\n");
        try {
            this.xmax = javaemul.internal.IntegerHelper.parseInt(this.getParameter("xmax"));
        }
        catch (e) {
            this.xmax = laby.xmaxdef;
        }
        ;
        try {
            this.ymax = javaemul.internal.IntegerHelper.parseInt(this.getParameter("ymax"));
        }
        catch (e) {
            this.ymax = laby.ymaxdef;
        }
        ;
        try {
            this.updt = javaemul.internal.BooleanHelper.valueOf(this.getParameter("updt"));
        }
        catch (e) {
            this.updt = laby.updtdef;
        }
        ;
        try {
            this.dbg = javaemul.internal.BooleanHelper.valueOf(this.getParameter("dbg"));
        }
        catch (e) {
            this.dbg = laby.dbgdef;
        }
        ;
        java.lang.System.out.print(" + Xmax = " + this.xmax + "\n");
        java.lang.System.out.print(" + Ymax = " + this.ymax + "\n");
        java.lang.System.out.print(" + Update = " + this.updt + "\n");
        java.lang.System.out.print(" + Debug = " + this.dbg + "\n");
        this.d = this.getSize();
        this.dx = (Math.floor((this.d.width / (this.xmax + 1) | 0)) | 0);
        this.dy = (Math.floor((this.d.height / (this.ymax + 1) | 0)) | 0);
        this.xshift = ((this.d.width - this.xmax * this.dx) / 2 | 0);
        this.yshift = ((this.d.height - this.ymax * this.dy) / 2 | 0);
        this.init_laby();
        this.repaint();
    };
    laby.prototype.start = function () {
        this.repaint();
    };
    laby.prototype.init_laby = function () {
        this.laby = (function (dims) { var allocate = function (dims) { if (dims.length == 0) {
            return 0;
        }
        else {
            var array = [];
            for (var i = 0; i < dims[0]; i++) {
                array.push(allocate(dims.slice(1)));
            }
            return array;
        } }; return allocate(dims); })([this.ymax + 2, this.xmax + 2]);
        for (var i = 0; i < this.xmax + 2; i++)
            for (var j = 0; j < this.ymax + 2; j++)
                this.laby[j][i] = laby.murX | laby.murY;
        ;
        for (var i = 0; i < this.ymax + 2; i++) {
            this.laby[i][0] = laby.murX | laby.murY | laby.fait | laby.bord;
            this.laby[i][this.xmax + 1] = laby.murX | laby.murY | laby.fait | laby.bord;
        }
        ;
        for (var i = 0; i < this.xmax + 2; i++) {
            this.laby[0][i] = laby.murX | laby.murY | laby.fait | laby.bord;
            this.laby[this.ymax + 1][i] = laby.murX | laby.murY | laby.fait | laby.bord;
        }
        ;
        this.random = new java.util.Random();
    };
    /**
     * This function is very important : the order of case will
     * deeply affect the maze.
     * You should replace this sample function by a more sophisticated
     * path finder.
     * @throws Exception when no more case are left.
     * @param {Array} last
     * @return {Array}
     */
    laby.prototype.getNextCase = function (last) {
        var coo;
        coo = last;
        if (coo[0] === -1) {
            coo[0] = 1;
            coo[1] = 1;
            this.laby[coo[1]][coo[0]] |= laby.fait;
        }
        while (((this.laby[coo[1]][coo[0]] & laby.fait) !== 0)) {
            if (coo[0] !== (this.xmax + 1)) {
                coo[0]++;
            }
            else if (coo[1] !== (this.ymax + 1)) {
                coo[0] = 1;
                coo[1]++;
            }
            else
                throw new laby.Exception_NoMoreCase(this);
        }
        ;
        return coo;
    };
    /**
     * This function tries to find a neighbourhood.
     * @param {boolean} need tells if the cell needs to be 'fait' or not.
     * @throws Exception_NoFoundCase when no matching cas has been found.
     * @param {Array} cur
     * @return {Array}
     */
    laby.prototype.findCase = function (cur, need) {
        var idir = this.random.nextInt() % 4;
        idir = (idir < 0) ? -idir : idir;
        var ret = [0, 0];
        for (var i = 0; i < 4; i++) {
            if ((((this.laby[cur[1] + laby.dir_$LI$()[2 * idir + 1]][cur[0] + laby.dir_$LI$()[2 * idir]] & laby.fait) !== 0) === need) && ((this.laby[cur[1] + laby.dir_$LI$()[2 * idir + 1]][cur[0] + laby.dir_$LI$()[2 * idir]] & laby.bord) === 0)) {
                ret[0] = cur[0] + laby.dir_$LI$()[2 * idir];
                ret[1] = cur[1] + laby.dir_$LI$()[2 * idir + 1];
                return ret;
            }
            idir = (idir === 3) ? 0 : idir + 1;
        }
        ;
        throw new laby.Exception_NoFoundCase(this);
    };
    laby.prototype.dig = function (case1, case2) {
        if (case1[0] === case2[0])
            this.eraseCase(case1[0], (case1[1] < case2[1]) ? case1[1] : case2[1], laby.murY);
        else
            this.eraseCase((case1[0] < case2[0]) ? case1[0] : case2[0], case1[1], laby.murX);
    };
    /**
     * This method generates the laby.
     * It just process all the cells by :
     * - linking to a previous cell
     * - digging, digging, digging,...
     */
    laby.prototype.gen_laby = function () {
        var cur;
        var tmp;
        var first = [-1, -1];
        try {
            while ((true)) {
                first = this.getNextCase(first);
                if (this.dbg)
                    java.lang.System.out.print("Current X=" + first[0] + ", Y=" + first[1] + "\n");
                this.faitCase(first[0], first[1]);
                tmp = this.findCase(first, true);
                if (this.dbg)
                    java.lang.System.out.print(" * Link X=" + tmp[0] + ", Y=" + tmp[1] + "\n");
                this.dig(first, tmp);
                cur = first;
                try {
                    while ((true)) {
                        tmp = this.findCase(cur, false);
                        if (this.dbg)
                            java.lang.System.out.print(" * Dig X=" + tmp[0] + ", Y=" + tmp[1] + "\n");
                        this.faitCase(tmp[0], tmp[1]);
                        this.dig(cur, tmp);
                        cur = tmp;
                    }
                    ;
                }
                catch (e) {
                }
                ;
            }
            ;
        }
        catch (__e) {
            if (__e != null && __e instanceof laby.Exception_NoMoreCase) {
                var e = __e;
            }
            if (__e != null && __e instanceof laby.Exception_NoFoundCase) {
                var e = __e;
                java.lang.System.out.print("Uh ?! bug.\n");
            }
        }
        ;
    };
    laby.prototype.destroy = function () {
    };
    laby.prototype.affCase = function (g, l, x, y) {
        if ((l & laby.murX) !== 0) {
            g.setColor(java.awt.Color.black);
            g.drawLine(x * this.dx + this.xshift + this.dx, y * this.dy + this.yshift, x * this.dx + this.xshift + this.dx, y * this.dy + this.yshift + this.dy);
        }
        else {
            g.setColor(java.awt.Color.white);
            g.drawLine(x * this.dx + this.xshift + this.dx, y * this.dy + this.yshift + 1, x * this.dx + this.xshift + this.dx, y * this.dy + this.yshift + this.dy - 1);
        }
        if ((l & laby.murY) !== 0) {
            g.setColor(java.awt.Color.black);
            g.drawLine(x * this.dx + this.xshift, y * this.dy + this.yshift + this.dy, x * this.dx + this.xshift + this.dx, y * this.dy + this.yshift + this.dy);
        }
        else {
            g.setColor(java.awt.Color.white);
            g.drawLine(x * this.dx + this.xshift + 1, y * this.dy + this.yshift + this.dy, x * this.dx + this.xshift + this.dx - 1, y * this.dy + this.yshift + this.dy);
        }
    };
    laby.prototype.paint = function (g) {
        var og;
        og = g;
        og.setColor(java.awt.Color.white);
        og.fillRect(0, 0, this.d.width, this.d.height);
        og.setColor(java.awt.Color.black);
        og.drawLine(this.xshift, this.yshift, this.xshift + this.dx * this.xmax, this.yshift);
        og.drawLine(this.xshift, this.yshift, this.xshift, this.yshift + this.dy * this.ymax);
        this.paint_cases(og, 1, 1, this.xmax + 1, this.ymax + 1);
        this.gen_laby();
    };
    laby.prototype.paint_cases = function (g, xmin, ymin, xmax, ymax) {
        for (var i = xmin; i < xmax; i++)
            for (var j = ymin; j < ymax; j++) {
                this.affCase(g, this.laby[j][i], i - 1, j - 1);
            }
        ;
        ;
    };
    laby.prototype.setCase = function (x, y, v) {
        this.laby[y][x] = (v | 0);
        if (this.updt) {
            this.affCase(this.getGraphics(), v, x - 1, y - 1);
        }
    };
    laby.prototype.eraseCase = function (x, y, mask) {
        this.setCase(x, y, this.laby[y][x] & (~mask));
    };
    laby.prototype.faitCase = function (x, y) {
        this.laby[y][x] |= (laby.fait | 0);
    };
    laby.prototype.getAppletInfo = function () {
        return "Laby";
    };
    return laby;
}(java.applet.Applet));
laby.xmaxdef = 50;
laby.ymaxdef = 30;
laby.updtdef = true;
laby.dbgdef = false;
laby.murX = 1;
laby.murY = 2;
laby.fait = 4;
laby.bord = 8;
laby["__class"] = "laby";
laby["__interfaces"] = ["java.awt.MenuContainer", "javax.accessibility.Accessible", "java.awt.image.ImageObserver", "java.io.Serializable"];
(function (laby) {
    var Exception_NoMoreCase = (function (_super) {
        __extends(Exception_NoMoreCase, _super);
        function Exception_NoMoreCase(__parent) {
            var _this = _super.call(this) || this;
            Object.setPrototypeOf(_this, Exception_NoMoreCase.prototype);
            _this.__parent = __parent;
            return _this;
        }
        return Exception_NoMoreCase;
    }(Error));
    laby.Exception_NoMoreCase = Exception_NoMoreCase;
    Exception_NoMoreCase["__class"] = "laby.Exception_NoMoreCase";
    Exception_NoMoreCase["__interfaces"] = ["java.io.Serializable"];
    var Exception_NoFoundCase = (function (_super) {
        __extends(Exception_NoFoundCase, _super);
        function Exception_NoFoundCase(__parent) {
            var _this = _super.call(this) || this;
            Object.setPrototypeOf(_this, Exception_NoFoundCase.prototype);
            _this.__parent = __parent;
            return _this;
        }
        return Exception_NoFoundCase;
    }(Error));
    laby.Exception_NoFoundCase = Exception_NoFoundCase;
    Exception_NoFoundCase["__class"] = "laby.Exception_NoFoundCase";
    Exception_NoFoundCase["__interfaces"] = ["java.io.Serializable"];
})(laby || (laby = {}));
laby.dir_$LI$();
